//package com.yilesoft.app.textimage.moveedit;
//
//import android.app.Activity;
//import android.app.Application;
//import android.content.Context;
//import android.graphics.Typeface;
//import android.os.Bundle;
//import androidx.annotation.NonNull;
//import android.support.multidex.MultiDex;
//import android.util.DisplayMetrics;
//import android.view.Display;
//import android.view.WindowManager;
//
//import com.danikula.videocache.HttpProxyCacheServer;
//import com.example.zhouqiong.richeditotandroid.uitls.CrashHandler;
//import com.example.zhouqiong.richeditotandroid.uitls.FontUtils;
//import com.example.zhouqiong.richeditotandroid.uitls.SharedPreferencesUtil;
//import com.example.zhouqiong.richeditotandroid.xzwkj.BuildConfig;
//import com.example.zhouqiong.richeditotandroid.xzwkj.component.InitializeService;
//import com.example.zhouqiong.richeditotandroid.xzwkj.di.component.AppComponent;
//import com.example.zhouqiong.richeditotandroid.xzwkj.di.component.DaggerAppComponent;
//import com.example.zhouqiong.richeditotandroid.xzwkj.di.module.AppModule;
//import com.example.zhouqiong.richeditotandroid.xzwkj.di.module.HttpModule;
//import com.example.zhouqiong.richeditotandroid.xzwkj.share.WechatShareManager;
//import com.example.zhouqiong.richeditotandroid.xzwkj.util.LogUtil;
//import com.facebook.drawee.backends.pipeline.Fresco;
//import com.just.wholewriter.json.Constant;
//import com.pgyersdk.Pgyer;
//import com.pgyersdk.crash.PgyCrashManager;
//import com.scwang.smartrefresh.layout.SmartRefreshLayout;
//import com.scwang.smartrefresh.layout.api.DefaultRefreshFooterCreator;
//import com.scwang.smartrefresh.layout.api.DefaultRefreshHeaderCreator;
//import com.scwang.smartrefresh.layout.api.RefreshFooter;
//import com.scwang.smartrefresh.layout.api.RefreshHeader;
//import com.scwang.smartrefresh.layout.api.RefreshLayout;
//import com.scwang.smartrefresh.layout.footer.ClassicsFooter;
//import com.scwang.smartrefresh.layout.header.ClassicsHeader;
//
//import java.util.ArrayList;
//import java.util.HashSet;
//import java.util.List;
//import java.util.Set;
//
//import cn.jpush.android.api.JPushInterface;
//
//public class App extends Application implements Application.ActivityLifecycleCallbacks {
//
//    private static final String TAG = "MainApplication";
//
//    public static Context mContext;
//    public static App app;
//    public static AppComponent appComponent;
//    private Set<Activity> allActivities;
//
//    public static int SCREEN_WIDTH = -1;
//    public static int SCREEN_HEIGHT = -1;
//    public static float DIMEN_RATE = -1.0F;
//    public static int DIMEN_DPI = -1;
//    private int countActivity = 0;//前台界面数
//
//    public static synchronized App getInstance() {
//        return app;
//    }
//
//    private HttpProxyCacheServer proxy;
//    private List<Typeface> typefaceList;
//
//    public static HttpProxyCacheServer getVideoCacheProxy(Context context) {
//        App app = (App) context.getApplicationContext();
//        return app.proxy == null ? (app.proxy = app.newProxy()) : app.proxy;
//    }
//
//    private HttpProxyCacheServer newProxy() {
//        return new HttpProxyCacheServer(this);
//    }
//
//    //    static {
////        AppCompatDelegate.setDefaultNightMode(
////                AppCompatDelegate.MODE_NIGHT_NO);
////    }
//    static {
//        SmartRefreshLayout.setDefaultRefreshHeaderCreator(new DefaultRefreshHeaderCreator() {
//            @NonNull
//            @Override
//            public RefreshHeader createRefreshHeader(@NonNull Context context, @NonNull RefreshLayout layout) {
//                return new ClassicsHeader(mContext);
//            }
//        });
//        SmartRefreshLayout.setDefaultRefreshFooterCreator(new DefaultRefreshFooterCreator() {
//            @NonNull
//            @Override
//            public RefreshFooter createRefreshFooter(@NonNull Context context, @NonNull RefreshLayout layout) {
//                return new ClassicsFooter(mContext);
//            }
//        });
//    }
//
//    @Override
//    public void onCreate() {
//        super.onCreate();
//        mContext = this.getApplicationContext();
//        app = this;
//        //加载字体库
//        initTypeFaceList();
//        //初始化屏幕宽高
//        getScreenSize();
//        //在子线程中完成其他初始化
//        InitializeService.start(this);
//        //init
//        //初始化sp
//        SharedPreferencesUtil.initSharedPreferences(mContext);
//        //初始化崩溃监听器，崩溃日志将存于 mnt/sdcard/crash 目录下
//        CrashHandler crashHandler = CrashHandler.getInstance();
//        crashHandler.init(this);
//
//        Fresco.initialize(this);
//
//        //注册微信
//        WechatShareManager.getInstance(app);
//        //蒲公英sdk所需
//        PgyCrashManager.register();
//        PgyCrashManager.setIsIgnoreDefaultHander(false); //默认设置为false;
//        //设置为 true ,则忽略系统默认Crash 操作，SDK 会重启启动 app 的当前页面
//        App.getAppComponent().preferencesHelper().cacheKeyId(new ArrayList());
//        //极光推送
//        JPushInterface.setDebugMode(BuildConfig.DEBUG);    // 设置开启日志,发布时请关闭日志
//        JPushInterface.init(this);            // 初始化 JPush
//        registerActivityLifecycleCallbacks(this);//注册APP生命周期监听
//    }
//
//    private void initTypeFaceList() {
//        if (typefaceList == null) {
//            typefaceList = new ArrayList<>();
//        }
//        for (int i = 0; i < 10; i++) {
//            if(i == 0){
//                typefaceList.add(Typeface.DEFAULT);
//            }else{
//                typefaceList.add(FontUtils.getTypeFace(getApplicationContext(), i));
//            }
//        }
//    }
//
//    public static App getApp() {
//        return app;
//    }
//
//    protected void attachBaseContext(Context base) {
//        super.attachBaseContext(base);
//        MultiDex.install(this);
//        Pgyer.setAppId(Constant.PGYER_APP_ID);
//    }
//
//    public void addActivity(Activity act) {
//        if (allActivities == null) {
//            allActivities = new HashSet<>();
//        }
//        allActivities.add(act);
//    }
//
//    public void removeActivity(Activity act) {
//        if (allActivities != null) {
//            allActivities.remove(act);
//        }
//    }
//
//    public void removeOtherActivity(Class c) {
//        if (allActivities != null) {
//            synchronized (allActivities) {
//                for (Activity act : allActivities) {
//                    if (!act.getClass().equals(c))
//                        act.finish();
//                }
//            }
//        }
//    }
//
//    public void exitApp() {
//        if (allActivities != null) {
//            synchronized (allActivities) {
//                for (Activity act : allActivities) {
//                    act.finish();
//                }
//            }
//        }
//        android.os.Process.killProcess(android.os.Process.myPid());
//        System.exit(0);
//    }
//
//    public void getScreenSize() {
//        WindowManager windowManager = (WindowManager) this.getSystemService(Context.WINDOW_SERVICE);
//        DisplayMetrics dm = new DisplayMetrics();
//        Display display = windowManager.getDefaultDisplay();
//        display.getMetrics(dm);
//        DIMEN_RATE = dm.density / 1.0F;
//        DIMEN_DPI = dm.densityDpi;
//        SCREEN_WIDTH = dm.widthPixels;
//        SCREEN_HEIGHT = dm.heightPixels;
//        if (SCREEN_WIDTH > SCREEN_HEIGHT) {
//            int t = SCREEN_HEIGHT;
//            SCREEN_HEIGHT = SCREEN_WIDTH;
//            SCREEN_WIDTH = t;
//        }
//    }
//
//    public static AppComponent getAppComponent() {
//        if (appComponent == null) {
//            appComponent = DaggerAppComponent.builder()
//                    .appModule(new AppModule(app))
//                    .httpModule(new HttpModule())
//                    .build();
//        }
//        return appComponent;
//    }
//
//    @Override
//    public void onActivityCreated(Activity activity, Bundle savedInstanceState) {
//
//    }
//
//    @Override
//    public void onActivitySaveInstanceState(Activity activity, Bundle outState) {
//
//    }
//
//    @Override
//    public void onActivityStarted(Activity activity) {
//        if (countActivity == 0) {
//            LogUtil.d(TAG + " APP running in foreground");
//            SharedPreferencesUtil.setBooleanDate(Constant.SPKEY_APP_FOREGROUND, true);
//        }
//        countActivity++;
//        LogUtil.d(TAG + " onActivityResumed : countActivity = " + countActivity);
//    }
//
//    @Override
//    public void onActivityResumed(Activity activity) {
//
//    }
//
//    @Override
//    public void onActivityPaused(Activity activity) {
//
//    }
//
//    @Override
//    public void onActivityStopped(Activity activity) {
//        countActivity--;
//        LogUtil.i(TAG + " onActivityStopped : countActivity=" + countActivity);
//        if (countActivity <= 0) {
//            LogUtil.d(TAG + " APP running in background");
//            SharedPreferencesUtil.setBooleanDate(Constant.SPKEY_APP_FOREGROUND, false);
//        }
//    }
//
//    @Override
//    public void onActivityDestroyed(Activity activity) {
//
//    }
//
//    public List<Typeface> getTypefaceList() {
//        return typefaceList;
//    }
//
//    public void setTypefaceList(List<Typeface> typefaceList) {
//        this.typefaceList = typefaceList;
//    }
//}
//
//
