package com.yilesoft.app.textimage.moveedit;

import java.io.Serializable;

public class Effects implements Serializable {

    //新版本增加效果：
    private boolean highLight,middleLine,bottomLine,italic,bold;
    private int fontId;
    //固有效果
    private int textColor;
    private int textSize;//sp sp sp !!!!!
    private boolean isTitleMode;

    public void switchBold(){
        this.bold = !bold;
    }

    public void switchItalic(){
        this.italic = !italic;
    }

    public void switchBottomLine(){
        this.bottomLine = !bottomLine;
    }

    public void switchMiddleLine(){
        this.middleLine = !middleLine;
    }

    public void switchHighLight(){
        this.highLight = !highLight;
    }

    public void switchTitleMode(){
        this.isTitleMode = !isTitleMode;
    }

    public boolean isHighLight() {
        return highLight;
    }

    public void setHighLight(boolean highLight) {
        this.highLight = highLight;
    }

    public boolean isMiddleLine() {
        return middleLine;
    }

    public void setMiddleLine(boolean middleLine) {
        this.middleLine = middleLine;
    }

    public boolean isBottomLine() {
        return bottomLine;
    }

    public void setBottomLine(boolean bottomLine) {
        this.bottomLine = bottomLine;
    }

    public boolean isItalic() {
        return italic;
    }

    public void setItalic(boolean italic) {
        this.italic = italic;
    }

    public boolean isBold() {
        return bold;
    }

    public void setBold(boolean bold) {
        this.bold = bold;
    }

    public int getFontId() {
        return fontId;
    }

    public void setFontId(int fontId) {
        this.fontId = fontId;
    }

    public int getTextColor() {
        return textColor;
    }

    public void setTextColor(int textColor) {
        this.textColor = textColor;
    }

    public int getTextSize() {
        return textSize;
    }

    public void setTextSize(int textSize) {
        this.textSize = textSize;
    }

    public boolean isTitleMode() {
        return isTitleMode;
    }

    public void setTitleMode(boolean titleMode) {
        isTitleMode = titleMode;
    }

    @Override
    public String toString() {
        return "Effects{" +
                "highLight=" + highLight +
                ", middleLine=" + middleLine +
                ", bottomLine=" + bottomLine +
                ", italic=" + italic +
                ", bold=" + bold +
                ", fontId=" + fontId +
                ", textColor=" + textColor +
                ", textSize=" + textSize +
                ", isTitleMode=" + isTitleMode +
                '}';
    }

}
