package com.yilesoft.app.textimage.moveedit;



import java.io.Serializable;

public class BubbleInfo implements Serializable {

    private static final long serialVersionUID = 2003464175802203850L;

    private int id;
    private String img_url;
    private int bg_top;
    private int bg_right;
    private int bg_buttom;
    private int bg_left;
    private int text_width;
    private int text_height;

    public BubbleInfo(String img_url, int bg_top, int bg_right, int bg_buttom, int bg_left, int text_width, int text_height) {
        this.img_url = img_url;
        this.bg_top = bg_top;
        this.bg_right = bg_right;
        this.bg_buttom = bg_buttom;
        this.bg_left = bg_left;
        this.text_width = text_width;
        this.text_height = text_height;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getImg_url() {
        return img_url;
    }

    public void setImg_url(String img_url) {
        this.img_url = img_url;
    }

    public int getBg_top() {
        return bg_top;
    }

    public void setBg_top(int bg_top) {
        this.bg_top = bg_top;
    }

    public int getBg_right() {
        return bg_right;
    }

    public void setBg_right(int bg_right) {
        this.bg_right = bg_right;
    }

    public int getBg_buttom() {
        return bg_buttom;
    }

    public void setBg_buttom(int bg_buttom) {
        this.bg_buttom = bg_buttom;
    }

    public int getBg_left() {
        return bg_left;
    }

    public void setBg_left(int bg_left) {
        this.bg_left = bg_left;
    }

    public int getText_width() {
        return text_width;
    }

    public void setText_width(int text_width) {
        this.text_width = text_width;
    }

    public int getText_height() {
        return text_height;
    }

    public void setText_height(int text_height) {
        this.text_height = text_height;
    }
}

