//package com.yilesoft.app.textimage.moveedit;
//
//import android.content.Context;
//import android.graphics.Typeface;
//import android.util.Log;
//import android.view.View;
//import android.widget.TextView;
//import android.widget.Toast;
//
//
//import com.yilesoft.app.textimage.R;
//
//import java.io.File;
//import java.io.IOException;
//import java.util.ArrayList;
//import java.util.Arrays;
//import java.util.List;
//
//public class FontUtils {
//
//    private static final String TAG = FontUtils.class.getSimpleName();
//
//    public static int FONT_ALEGREYA_REGULAR = 0;
//    public static int FONT_BADSCRIPT_REGULAR = 1;
//    public static int FONT_BARLOW_CONDENSED_BOLD = 2;
//    public static int FONT_PANGMEN = 3;
//    public static int FONT_SHOUSHU = 4;
//    public static int FONT_SIYUANHEI_LIGHT = 5;
//    public static int FONT_SIYUANHEI_MEDIUM = 6;
//    public static int FONT_WANGHANZONG_FANSONG_JIAN = 7;
//    public static int FONT_WANGHANZONG_ZHONGWEIBEI_JIAN = 8;
//    public static int FONT_YANGRENDONG_ZHUSHITI_BOLD = 9;
//
//    /**
//     * 加载字体库
//     *
//     * @param fontLibBean 字体库bean
//     */
//    public static void loadFontLib(final Context context, final FontLibBean fontLibBean, TextView textView) {
//        Typeface pangmen = Typeface.createFromAsset(context.getAssets(), fontLibBean.getPath());
//        textView.setTypeface(pangmen);
//        textView.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//                Toast.makeText(context, fontLibBean.getName(), Toast.LENGTH_SHORT).show();
//            }
//        });
//    }
//
//    /**
//     * 填充字体
//     * @param context 上下文
//     * @param fontId 字体库对应id（见该类最上方定义）
//     * @param customsEditText 要填充的customsEditText
//     */
//    public static void loadFontLib(Context context,int fontId, CustomsEditText customsEditText){
//        String[] fontArray = context.getResources().getStringArray(R.array.font_name_array);
//        String fontPath = fontArray[fontId];
//        LogUtil.i(TAG+" loadFontLib : fontPath = "+fontPath);
//        Typeface typeface = Typeface.createFromAsset(context.getAssets(),fontPath);
//        customsEditText.setTypeface(typeface);
//    }
//
//    public static Typeface getTypeFace(Context context,int fontId){
//        String[] fontArray = context.getResources().getStringArray(R.array.font_name_array);
//        String fontPath = "font"+File.separator +fontArray[fontId];
//        return Typeface.createFromAsset(context.getAssets(),fontPath);
//    }
//
//    public static Typeface getTypeFace(int fontId){
//        return App.getApp().getTypefaceList().get(fontId);
//    }
//
//    /**
//     * 获取字体库bean列表
//     */
//    public static List<FontLibBean> createFontLibList(Context context) throws IOException {
//        List<FontLibBean> fontLibBeanList = new ArrayList<>();
//        String[] filePaths = context.getAssets().list("font");
//        if (filePaths != null && filePaths.length > 0) {
//            Log.i(TAG, Arrays.toString(filePaths));
//            for (int i = 0; i < filePaths.length; i++) {
//                FontLibBean libBean = new FontLibBean();
//                libBean.setId(i);
//                libBean.setName(filePaths[i]);
//                libBean.setPath(filePaths[i]);
//                fontLibBeanList.add(libBean);
//            }
//        } else {
//            Log.e(TAG, " filePaths is empty");
//        }
//        return fontLibBeanList;
//    }
//
////    public static Typeface getTypeFace(Context context,String fontName){
////        LogUtil.i(TAG+" fontName = "+fontName);
////        Typeface typeface = App.getApp().getTypefaceList().get(Constant.DEFAULT_FONT_TYPE_INDEX);
////        int index = Constant.DEFAULT_FONT_TYPE_INDEX;
////        String[] nameArray = context.getResources().getStringArray(R.array.font_name_array);
////        for(int i=0;i<nameArray.length;i++){
////            if(nameArray[i].contains(fontName)){
////                index = i;
////                break;
////            }
////        }
////        return index==Constant.DEFAULT_FONT_TYPE_INDEX?typeface:App.getApp().getTypefaceList().get(index);
////    }
//
//    /**
//     *
//     * @param fontId id+""
//     * @return id对应的typeFace
//     */
//    public static Typeface getTypeFace(Context context,String fontId){
//        LogUtil.i(TAG+" getTypeFace : fontId = "+fontId);
//        return App.getApp().getTypefaceList().get(Integer.parseInt(fontId));
//    }
//
//}
